Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionBudget/FrmConstructionBudgetAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionBudget/FrmConstructionBudgetAuxiliary.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionBudget/FrmConstructionBudgetAuxiliary.cs	(revision 51)
@@ -4247,7 +4572,124 @@
         }
         #endregion
 
+        #region 経費変更画面表示
+        /// <summary>
+        /// 経費変更画面表示
+        /// </summary>
+        private void DspChangeExpens()
+        {
+            FrmChangeExpenses frm = new FrmChangeExpenses();
+            try
+            {
+                // データ取得
+                ArrayList GridExpens = new ArrayList();
+                GetExpensesData(ref GridExpens);
 
+                // パラメタセット
+                frm.OrdersPrice = label6.Text;
+                frm.GridData = GridExpens;
+
+                // 画面表示
+                frm.ShowDialog();
+
+                // 終了時キャンセルは以下を処理しない
+                if (frm.EndButton == DialogResult.Cancel) return;
+
+                // データセット
+                SetExpensesData(frm.GridData);
+
+                // 合計金額
+                CreateAllTotal(false);
+
+                // 変更フラグON
+                m_bChengeAns = true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 画面より経費データを取得する
+        /// <summary>
+        /// 画面より経費データを取得する
+        /// </summary>
+        /// <param name="GridExpens"></param>
+        private void GetExpensesData(ref ArrayList GridExpens)
+        {
+            try
+            {
+                DataGridView dgv = dgvAllDisplay;
+
+                for (int i = 0; i < dgv.RowCount; i++)
+                {
+                    DataGridViewRow CurRow = dgv.Rows[i];
+                    int GroupNo = CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.GroupCount].Value);
+                    int ComponentCode = CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.ComponentCode].Value);
+                    if (GroupNo != (int)DataGroup.Expenses) continue;
+                    if (ComponentCode == 0) continue;
+
+                    // 経費を取得する
+                    string ExpensName = CommonMotions.cnvString(CurRow.Cells[(int)GridColumn.ItemName].Value);
+
+                    object[] DataRec = new object[] { CurRow.Cells[(int)GridColumn.No].Value,
+                                                        CurRow.Cells[(int)GridColumn.ComponentCode].Value,
+                                                        ExpensName.Substring(0, ExpensName.IndexOf("(")),
+                                                        CurRow.Cells[(int)GridColumn.Percent].Value,
+                                                        CurRow.Cells[(int)GridColumn.ExecPrice].Value
+                    };
+                    GridExpens.Add(DataRec);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 変更経費表示処理
+        /// <summary>
+        /// 変更経費表示処理
+        /// </summary>
+        /// <param name="ExpensList"></param>
+        private void SetExpensesData(ArrayList ExpensList)
+        {
+            try
+            {
+                if (ExpensList.Count == 0) return;
+
+                DataGridView dgv = dgvAllDisplay;
+                int ListCnt = 0;
+                for (int i = 0; i < dgv.RowCount; i++)
+                {
+                    DataGridViewRow CurRow = dgv.Rows[i];
+                    int GroupNo = CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.GroupCount].Value);
+                    if (GroupNo != (int)DataGroup.Expenses) continue;
+                    int ComponentCode = CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.ComponentCode].Value);
+                    if (ComponentCode == 0) continue;
+
+                    object[] DataRec = (object[])ExpensList[ListCnt];
+
+                    CurRow.Cells[(int)GridColumn.ItemName].Value = string.Format("{0}({1}%)", DataRec[2], CommonMotions.cnvDouble(DataRec[3]).ToString("0.00"));
+                    CurRow.Cells[(int)GridColumn.HopePrice].Value = CommonMotions.cnvInt(DataRec[4]).ToString("#,#");
+                    CurRow.Cells[(int)GridColumn.ExecPrice].Value = CommonMotions.cnvInt(DataRec[4]).ToString("#,#");
+                    CurRow.Cells[(int)GridColumn.Percent].Value = CommonMotions.cnvDouble(DataRec[3]).ToString("0.00");
+
+                    ListCnt++;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
         // ---------- データコンバートロジック
         #region 給与計算
         /// <summary>
@@ -4302,7 +4744,7 @@
                             }
                         }
 
-                        AbortFlg = ClsChangeLedgerData.CalculatePayment(LedgerRec.ConstructionCode, paraD, true);
+                        AbortFlg = ClsChangeLedgerData.CalculatePayment(LedgerRec, paraD, DateTime.MinValue);
                         if (!AbortFlg) break;
                         if (EndProc) break;
                     }
@@ -4346,126 +4788,171 @@
         /// <summary>
         /// 経費再計算
         /// </summary>
-        private void CalcExpenese()
+        //private void CalcExpenese()
+        //{
+            //IOConstructionLedger LedgerDB = new IOConstructionLedger();
+            //IOConstructionLedgerDetail LedgerDDB = new IOConstructionLedgerDetail();
+            //IOConstructionLedgerExcute LedgerEDB = new IOConstructionLedgerExcute();
+            //FrmConstructionLedger frm = new FrmConstructionLedger();
+
+            //try
+            //{
+            //    LedgerDB.connect(); LedgerDB.beginTran();
+            //    LedgerDDB.connect();LedgerDDB.beginTran();
+            //    LedgerEDB.connect(); LedgerEDB.beginTran();
+                
+            //    // 経費率のセット
+            //    string strSQL1 = "SELECT A.CONSTRUCTIONCODE, E.DETAILSTRING, F.DEPARTMENTSTRING, A.LINECOUNT, A.FIRSTSTRING";
+            //    strSQL1 += ", A.EXECUTIONAMOUNT, A.AMOUNTCONFIGRATE, B.CONSTRUCTIONPERIOD, C.DEPARTMENTCODE, D.NAMECODE";
+            //    strSQL1 += ", D.EXPENSESRATIO, ROUND(B.ORDERSDECISIONPRICE * (A.AMOUNTCONFIGRATE / 100.0)), G.NAMESTRING";
+            //    strSQL1 += " FROM CONSTRUCTIONLEDGERDETAIL A, CONSTRUCTIONBASEINFO B, PERSONINCHARGEMASTER C, DEPARTMENTEXPENSESMASTER D, CONSTRUCTIONBASEINFODETAIL E, DEPARTMENTMASTER F, DIVISIONMASTER G";
+            //    strSQL1 += " WHERE A.CONSTRUCTIONCODE <> 2015043401";
+            //    strSQL1 += " AND A.GROUPCOUNT = 1";
+            //    strSQL1 += " AND A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE";
+            //    strSQL1 += " AND B.CONSTRUCTIONPERIOD = 16";
+            //    strSQL1 += " AND B.CONSTRUCTIONPERSONCODE = C.PERSONCODE";
+            //    strSQL1 += " AND (C.DEPARTMENTCODE = D.DEPARTMENTCODE AND B.CONSTRUCTIONPERIOD = D.EXPENSESPERIOD AND D.DISPLAYORDER = (A.LINECOUNT - 1))";
+            //    strSQL1 += " AND E.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE AND E.DETAILNO = 2";
+            //    strSQL1 += " AND F.DEPARTMENTCODE = C.DEPARTMENTCODE";
+            //    strSQL1 += " AND G.DIVISIONCODE = 3";
+            //    strSQL1 += " AND G.NAMECODE = D.NAMECODE";
+            //    strSQL1 += " ORDER BY A.CONSTRUCTIONCODE, A.LINECOUNT";
+            //    ArrayList arList = new ArrayList();
+            //    if (!LedgerDB.ExecuteReader(strSQL1, ref arList, false)) return;
+            //    foreach (object[] CurRec in arList)
+            //    {
+            //        int CurConstrCode = CommonMotions.cnvInt(CurRec[(int)Read1Enum.CONSTRUCTIONCODE]);
+            //        int CurLineCnt = CommonMotions.cnvInt(CurRec[(int)Read1Enum.LINECOUNT]);
+            //        int CurCompnentCode = CommonMotions.cnvInt(CurRec[(int)Read1Enum.NAMECODE]);
+            //        double CurParcent = CommonMotions.cnvDouble(CurRec[(int)Read1Enum.EXPENSESRATIO]);
+            //        int CurValue = CommonMotions.cnvInt(CurRec[(int)Read1Enum.EXPENESE]);
+            //        string strValue = CommonMotions.cnvString(CurRec[(int)Read1Enum.EXPENESENAME]) + string.Format("({0}%)", CurParcent.ToString("0.00"));
+            //        // 項目名
+            //        if (!LedgerDDB.UpdateFeild(CurConstrCode, (int)IOConstructionLedgerDetail.DataColumn.FirstString, strValue, 1, CurLineCnt, false))
+            //        {
+            //            LedgerDDB.rollback();
+            //            return;
+            //        }
+            //        // 実行金額
+            //        if (!LedgerDDB.UpdateFeild(CurConstrCode, (int)IOConstructionLedgerDetail.DataColumn.ExecutionAmount, CurValue, 1, CurLineCnt, false))
+            //        {
+            //            LedgerDDB.rollback();
+            //            return;
+            //        }
+            //        // 経費率セット
+            //        if (!LedgerDDB.UpdateFeild(CurConstrCode, (int)IOConstructionLedgerDetail.DataColumn.AmountConfigRate, CurParcent, 1, CurLineCnt, false))
+            //        {
+            //            LedgerDDB.rollback();
+            //            return;
+            //        }
+            //        // 経費コード
+            //        if (!LedgerDDB.UpdateFeild(CurConstrCode, (int)IOConstructionLedgerDetail.DataColumn.ComponentCode, CurCompnentCode, 1, CurLineCnt, false))
+            //        {
+            //            LedgerDDB.rollback();
+            //            return;
+            //        }
+            //    }
+
+            //    string strSQL2 = "SELECT A.CONSTRUCTIONCODE, A.TYINGFLG, B.CONSTRUCTIONCODE, B.LINECOUNT, B.DataCnt,";
+            //    strSQL2 += " C.CONSTRUCTIONCODE, C.GROUPCOUNT, C.LINECOUNT, C.COLUMNCOUNT,";
+            //    strSQL2 += " ROUND(A.ORDERSDECISIONPRICE * (D.AMOUNTCONFIGRATE / 100.0))";
+            //    strSQL2 += " FROM CONSTRUCTIONBASEINFO A,";
+            //    strSQL2 += " (SELECT CONSTRUCTIONCODE, LINECOUNT, COUNT(*) DataCnt FROM CONSTRUCTIONLEDGEREXCUTE WHERE GROUPCOUNT = 1 GROUP BY CONSTRUCTIONCODE, LINECOUNT) B,";
+            //    strSQL2 += " CONSTRUCTIONLEDGEREXCUTE C,";
+            //    strSQL2 += " CONSTRUCTIONLEDGERDETAIL D";
+            //    strSQL2 += " WHERE A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE";
+            //    strSQL2 += " AND A.CONSTRUCTIONCODE <> 2015043401";
+            //    strSQL2 += " AND B.DataCnt = 1";
+            //    strSQL2 += " AND C.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
+            //    strSQL2 += " AND C.GROUPCOUNT = 1";
+            //    strSQL2 += " AND C.LINECOUNT = B.LINECOUNT";
+            //    strSQL2 += " AND D.CONSTRUCTIONCODE = C.CONSTRUCTIONCODE";
+            //    strSQL2 += " AND D.GROUPCOUNT = C.GROUPCOUNT";
+            //    strSQL2 += " AND D.LINECOUNT = C.LINECOUNT";
+            //    strSQL2 += " ORDER BY C.CONSTRUCTIONCODE, C.GROUPCOUNT, C.LINECOUNT, C.COLUMNCOUNT";
+            //    ArrayList arList2 = new ArrayList();
+            //    if (!LedgerEDB.ExecuteReader(strSQL2, ref arList2, false))
+            //    {
+            //        LedgerDDB.rollback();
+            //        return;
+            //    }
+            //    foreach (object[] CurRec in arList2)
+            //    {
+            //        int CONSTRUCTIONCODE = CommonMotions.cnvInt(CurRec[0]);
+            //        int TYINGFLG = CommonMotions.cnvInt(CurRec[1]);
+            //        int CONSTRUCTIONCODE2 = CommonMotions.cnvInt(CurRec[2]);
+            //        int LINECOUNT = CommonMotions.cnvInt(CurRec[3]);
+            //        int DataCnt = CommonMotions.cnvInt(CurRec[4]);
+            //        int CONSTRUCTIONCODE3 = CommonMotions.cnvInt(CurRec[5]);
+            //        int GROUPCOUNT = CommonMotions.cnvInt(CurRec[6]);
+            //        int LINECOUNT2 = CommonMotions.cnvInt(CurRec[7]);
+            //        int COLUMNCOUNT = CommonMotions.cnvInt(CurRec[8]);
+            //        int iValue =CommonMotions.cnvInt(CurRec[9]);
+
+            //        if (!LedgerEDB.UpdateFeild(CONSTRUCTIONCODE3, GROUPCOUNT, LINECOUNT2, COLUMNCOUNT, (int)IOConstructionLedgerExcute.TableColumn.PaymentAmount, iValue, false))
+            //        {
+            //            LedgerDDB.rollback();
+            //            return;
+            //        }
+            //    }
+
+            //    LedgerDB.commit();
+            //    LedgerDDB.commit();
+            //    LedgerEDB.commit();
+
+            //    string strSQL3 = "SELECT A.CONSTRUCTIONCODE FROM CONSTRUCTIONLEDGER A, CONSTRUCTIONBASEINFO B";
+            //    strSQL3 += " WHERE A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE";
+            //    strSQL3 += " AND B.CONSTRUCTIONPERIOD = 16";
+            //    strSQL3 += " ORDER BY A.CONSTRUCTIONCODE";
+            //    ArrayList arList3 = new ArrayList();
+            //    if (!LedgerDB.ExecuteReader(strSQL3, ref arList3)) return;
+            //    foreach (object[] CurRec in arList3)
+            //    {
+            //        // 工事コードのセット
+            //        frm.ConstructionCode = CommonMotions.cnvInt(CurRec[0]);
+
+            //        // 見えない画面を出す
+            //        frm.Hide();
+            //        // フォーム非表示
+            //        //frm.Visible = false;
+
+            //        // 再計算処理
+            //        if (!frm.RecalculateLedger) break;
+            //    }
+            //    // 画面を閉じる
+            //    frm.Close();
+            //}
+            //catch (Exception ex)
+            //{
+            //    logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            //}
+            //finally
+            //{
+            //    LedgerDB.close(); LedgerDB = null;
+            //    LedgerDDB.close(); LedgerDDB = null;
+            //    LedgerEDB.close(); LedgerEDB = null;
+
+            //    frm.Dispose(); frm = null;
+            //}
+        //}
+        #endregion
+
+        #region 未作成データ行作成処理
+        /// <summary>
+        /// 未作成データ行作成処理
+        /// </summary>
+        private void CreateOhtherData()
         {
             IOConstructionLedger LedgerDB = new IOConstructionLedger();
-            IOConstructionLedgerDetail LedgerDDB = new IOConstructionLedgerDetail();
-            IOConstructionLedgerExcute LedgerEDB = new IOConstructionLedgerExcute();
             FrmConstructionLedger frm = new FrmConstructionLedger();
 
             try
             {
-                LedgerDB.connect(); LedgerDB.beginTran();
-                LedgerDDB.connect();LedgerDDB.beginTran();
-                LedgerEDB.connect(); LedgerEDB.beginTran();
-                
-                // 経費率のセット
-                string strSQL1 = "SELECT A.CONSTRUCTIONCODE, E.DETAILSTRING, F.DEPARTMENTSTRING, A.LINECOUNT, A.FIRSTSTRING";
-                strSQL1 += ", A.EXECUTIONAMOUNT, A.AMOUNTCONFIGRATE, B.CONSTRUCTIONPERIOD, C.DEPARTMENTCODE, D.NAMECODE";
-                strSQL1 += ", D.EXPENSESRATIO, ROUND(B.ORDERSDECISIONPRICE * (A.AMOUNTCONFIGRATE / 100.0)), G.NAMESTRING";
-                strSQL1 += " FROM CONSTRUCTIONLEDGERDETAIL A, CONSTRUCTIONBASEINFO B, PERSONINCHARGEMASTER C, DEPARTMENTEXPENSESMASTER D, CONSTRUCTIONBASEINFODETAIL E, DEPARTMENTMASTER F, DIVISIONMASTER G";
-                strSQL1 += " WHERE A.CONSTRUCTIONCODE <> 2015043401";
-                strSQL1 += " AND A.GROUPCOUNT = 1";
-                strSQL1 += " AND A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE";
-                strSQL1 += " AND B.CONSTRUCTIONPERIOD = 16";
-                strSQL1 += " AND B.CONSTRUCTIONPERSONCODE = C.PERSONCODE";
-                strSQL1 += " AND (C.DEPARTMENTCODE = D.DEPARTMENTCODE AND B.CONSTRUCTIONPERIOD = D.EXPENSESPERIOD AND D.DISPLAYORDER = (A.LINECOUNT - 1))";
-                strSQL1 += " AND E.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE AND E.DETAILNO = 2";
-                strSQL1 += " AND F.DEPARTMENTCODE = C.DEPARTMENTCODE";
-                strSQL1 += " AND G.DIVISIONCODE = 3";
-                strSQL1 += " AND G.NAMECODE = D.NAMECODE";
-                strSQL1 += " ORDER BY A.CONSTRUCTIONCODE, A.LINECOUNT";
+                string strSQL = "SELECT B.CONSTRUCTIONCODE FROM CONSTRUCTIONLEDGER A, CONSTRUCTIONBASEINFO B WHERE A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE AND B.CONSTRUCTIONPERIOD = 16";
                 ArrayList arList = new ArrayList();
-                if (!LedgerDB.ExecuteReader(strSQL1, ref arList, false)) return;
+                if (!LedgerDB.ExecuteReader(strSQL, ref arList)) return;
                 foreach (object[] CurRec in arList)
                 {
-                    int CurConstrCode = CommonMotions.cnvInt(CurRec[(int)Read1Enum.CONSTRUCTIONCODE]);
-                    int CurLineCnt = CommonMotions.cnvInt(CurRec[(int)Read1Enum.LINECOUNT]);
-                    int CurCompnentCode = CommonMotions.cnvInt(CurRec[(int)Read1Enum.NAMECODE]);
-                    double CurParcent = CommonMotions.cnvDouble(CurRec[(int)Read1Enum.EXPENSESRATIO]);
-                    int CurValue = CommonMotions.cnvInt(CurRec[(int)Read1Enum.EXPENESE]);
-                    string strValue = CommonMotions.cnvString(CurRec[(int)Read1Enum.EXPENESENAME]) + string.Format("({0}%)", CurParcent.ToString("0.00"));
-                    // 項目名
-                    if (!LedgerDDB.UpdateFeild(CurConstrCode, (int)IOConstructionLedgerDetail.DataColumn.FirstString, strValue, 1, CurLineCnt, false))
-                    {
-                        LedgerDDB.rollback();
-                        return;
-                    }
-                    // 実行金額
-                    if (!LedgerDDB.UpdateFeild(CurConstrCode, (int)IOConstructionLedgerDetail.DataColumn.ExecutionAmount, CurValue, 1, CurLineCnt, false))
-                    {
-                        LedgerDDB.rollback();
-                        return;
-                    }
-                    // 経費率セット
-                    if (!LedgerDDB.UpdateFeild(CurConstrCode, (int)IOConstructionLedgerDetail.DataColumn.AmountConfigRate, CurParcent, 1, CurLineCnt, false))
-                    {
-                        LedgerDDB.rollback();
-                        return;
-                    }
-                    // 経費コード
-                    if (!LedgerDDB.UpdateFeild(CurConstrCode, (int)IOConstructionLedgerDetail.DataColumn.ComponentCode, CurCompnentCode, 1, CurLineCnt, false))
-                    {
-                        LedgerDDB.rollback();
-                        return;
-                    }
-                }
-
-                string strSQL2 = "SELECT A.CONSTRUCTIONCODE, A.TYINGFLG, B.CONSTRUCTIONCODE, B.LINECOUNT, B.DataCnt,";
-                strSQL2 += " C.CONSTRUCTIONCODE, C.GROUPCOUNT, C.LINECOUNT, C.COLUMNCOUNT,";
-                strSQL2 += " ROUND(A.ORDERSDECISIONPRICE * (D.AMOUNTCONFIGRATE / 100.0))";
-                strSQL2 += " FROM CONSTRUCTIONBASEINFO A,";
-                strSQL2 += " (SELECT CONSTRUCTIONCODE, LINECOUNT, COUNT(*) DataCnt FROM CONSTRUCTIONLEDGEREXCUTE WHERE GROUPCOUNT = 1 GROUP BY CONSTRUCTIONCODE, LINECOUNT) B,";
-                strSQL2 += " CONSTRUCTIONLEDGEREXCUTE C,";
-                strSQL2 += " CONSTRUCTIONLEDGERDETAIL D";
-                strSQL2 += " WHERE A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE";
-                strSQL2 += " AND A.CONSTRUCTIONCODE <> 2015043401";
-                strSQL2 += " AND B.DataCnt = 1";
-                strSQL2 += " AND C.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
-                strSQL2 += " AND C.GROUPCOUNT = 1";
-                strSQL2 += " AND C.LINECOUNT = B.LINECOUNT";
-                strSQL2 += " AND D.CONSTRUCTIONCODE = C.CONSTRUCTIONCODE";
-                strSQL2 += " AND D.GROUPCOUNT = C.GROUPCOUNT";
-                strSQL2 += " AND D.LINECOUNT = C.LINECOUNT";
-                strSQL2 += " ORDER BY C.CONSTRUCTIONCODE, C.GROUPCOUNT, C.LINECOUNT, C.COLUMNCOUNT";
-                ArrayList arList2 = new ArrayList();
-                if (!LedgerEDB.ExecuteReader(strSQL2, ref arList2, false))
-                {
-                    LedgerDDB.rollback();
-                    return;
-                }
-                foreach (object[] CurRec in arList2)
-                {
-                    int CONSTRUCTIONCODE = CommonMotions.cnvInt(CurRec[0]);
-                    int TYINGFLG = CommonMotions.cnvInt(CurRec[1]);
-                    int CONSTRUCTIONCODE2 = CommonMotions.cnvInt(CurRec[2]);
-                    int LINECOUNT = CommonMotions.cnvInt(CurRec[3]);
-                    int DataCnt = CommonMotions.cnvInt(CurRec[4]);
-                    int CONSTRUCTIONCODE3 = CommonMotions.cnvInt(CurRec[5]);
-                    int GROUPCOUNT = CommonMotions.cnvInt(CurRec[6]);
-                    int LINECOUNT2 = CommonMotions.cnvInt(CurRec[7]);
-                    int COLUMNCOUNT = CommonMotions.cnvInt(CurRec[8]);
-                    int iValue =CommonMotions.cnvInt(CurRec[9]);
-
-                    if (!LedgerEDB.UpdateFeild(CONSTRUCTIONCODE3, GROUPCOUNT, LINECOUNT2, COLUMNCOUNT, (int)IOConstructionLedgerExcute.TableColumn.PaymentAmount, iValue, false))
-                    {
-                        LedgerDDB.rollback();
-                        return;
-                    }
-                }
-
-                LedgerDB.commit();
-                LedgerDDB.commit();
-                LedgerEDB.commit();
-
-                string strSQL3 = "SELECT A.CONSTRUCTIONCODE FROM CONSTRUCTIONLEDGER A, CONSTRUCTIONBASEINFO B";
-                strSQL3 += " WHERE A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE";
-                strSQL3 += " AND B.CONSTRUCTIONPERIOD = 16";
-                strSQL3 += " ORDER BY A.CONSTRUCTIONCODE";
-                ArrayList arList3 = new ArrayList();
-                if (!LedgerDB.ExecuteReader(strSQL3, ref arList3)) return;
-                foreach (object[] CurRec in arList3)
-                {
                     // 工事コードのセット
                     frm.ConstructionCode = CommonMotions.cnvInt(CurRec[0]);
 
@@ -4487,8 +4974,6 @@
             finally
             {
                 LedgerDB.close(); LedgerDB = null;
-                LedgerDDB.close(); LedgerDDB = null;
-                LedgerEDB.close(); LedgerEDB = null;
 
                 frm.Dispose(); frm = null;
             }
@@ -4495,33 +4980,148 @@
         }
         #endregion
 
-        #region 未作成データ行作成処理
+        #region 給料開始月再計算
         /// <summary>
-        /// 未作成データ行作成処理
+        /// 給料開始月再計算
         /// </summary>
-        private void CreateOhtherData()
+        private void RecalculateLedgerData()
         {
             IOConstructionLedger LedgerDB = new IOConstructionLedger();
-            FrmConstructionLedger frm = new FrmConstructionLedger();
-
+            IOConstructionLedgerDetail DetailDB = new IOConstructionLedgerDetail();
+            IOConstructionLedgerExcute ExecDB = new IOConstructionLedgerExcute();
             try
             {
-                string strSQL = "SELECT B.CONSTRUCTIONCODE FROM CONSTRUCTIONLEDGER A, CONSTRUCTIONBASEINFO B WHERE A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE AND B.CONSTRUCTIONPERIOD = 16";
+
+                // 16期の対象データを取得する
+                string strSQL = "SELECT A.CONSTRUCTIONCODE,";
+                //strSQL += " TO_CHAR(A.CONSTRUCTIONSTART,'YYYY/MM/DD') SDate,";
+                //strSQL += " TO_CHAR(B.CONSTRUCTIONCOMPLETIONDATE,'YYYY/MM/DD') EDate1,";
+                //strSQL += " TO_CHAR(B.BILLINGSTARTDATE,'YYYY/MM/DD')  EDate2";
+                strSQL += " DATE_FORMAT(A.CONSTRUCTIONSTART,'%Y/%m/%d') SDate,";
+                strSQL += " DATE_FORMAT(B.CONSTRUCTIONCOMPLETIONDATE,'%Y/%m/%d') EDate1,";
+                strSQL += " DATE_FORMAT(B.BILLINGSTARTDATE,'%Y/%m/%d')  EDate2";
+                strSQL += " FROM CONSTRUCTIONLEDGER A, CONSTRUCTIONBASEINFO B";
+                strSQL += " WHERE A.CONSTRUCTIONPERIOD = 16";
+                strSQL += " AND DATE(A.CONSTRUCTIONSTART) < DATE(NOW())";
+                strSQL += " AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
+                strSQL += " ORDER BY A.CONSTRUCTIONCODE";
+
                 ArrayList arList = new ArrayList();
                 if (!LedgerDB.ExecuteReader(strSQL, ref arList)) return;
-                foreach (object[] CurRec in arList)
+
+                DetailDB.connect(); DetailDB.beginTran();
+                ExecDB.connect(); ExecDB.beginTran();
+
+                foreach (object[] wrkRec in arList)
                 {
-                    // 工事コードのセット
-                    frm.ConstructionCode = CommonMotions.cnvInt(CurRec[0]);
+                    int Constrcode = CommonMotions.cnvInt(wrkRec[0]);
+                    DateTime SDate = CommonMotions.cnvDate(wrkRec[1]);
+                    DateTime EDate1 = CommonMotions.cnvDate(wrkRec[2]);
+                    DateTime EDate2 = CommonMotions.cnvDate(wrkRec[3]);
+                    DateTime EndDate = EDate1;
 
-                    // 見えない画面を出す
-                    frm.Hide();
-                    // フォーム非表示
-                    //frm.Visible = false;
+                    // 終了していないデータは除外する
+                    if (EDate1.Date == DateTime.Parse("0001/01/01")
+                        && EDate2.Date == DateTime.Parse("0001/01/01")) continue;
 
-                    // 再計算処理
-                    if (!frm.RecalculateLedger) break;
+                    // 終了日付を取得する
+                    if (EndDate == DateTime.Parse("0001/01/01")) EndDate = EDate2;
+                    if (EDate2 != DateTime.Parse("0001/01/01") && EndDate > EDate2) EndDate = EDate2;
+
+                    // 経過日付を取得する
+                    int AfterDays = 0;
+                    if (SDate.Year == EndDate.Year && SDate.Month == EndDate.Month)
+                    {
+                        TimeSpan ts = EndDate - SDate;
+                        AfterDays = ts.Days + 1;
+                    }
+                    else
+                    {
+                        DateTime LastDay = DateTimeUtil.EndOfMonth(SDate);
+                        AfterDays = (LastDay.Day - SDate.Day) + 1;
+                    }
+
+                    string strDetail = "SELECT A.CONSTRUCTIONCODE, B.GROUPCOUNT, B.LINECOUNT, MIN(B.COLUMNCOUNT), C.PERSONCODE, C.PERSONNAME, C.MONTHLYSALARY, A.SALARYDAYS";
+                    strDetail += " FROM CONSTRUCTIONLEDGERDETAIL A, CONSTRUCTIONLEDGEREXCUTE B, PERSONINCHARGEMASTER C";
+                    strDetail += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", Constrcode);
+                    strDetail += " AND A.OPERATINGFLG = 1 AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
+                    strDetail += " AND (A.GROUPCOUNT = 9 Or A.GROUPCOUNT = 10 Or A.GROUPCOUNT = 11)";
+                    strDetail += " AND B.LINECOUNT = A.LINECOUNT AND C.PERSONCODE = A.COMPANYCODE";
+                    strDetail += " GROUP BY A.CONSTRUCTIONCODE, B.GROUPCOUNT, B.LINECOUNT, C.PERSONCODE, C.PERSONNAME, C.MONTHLYSALARY, A.SALARYDAYS";
+
+                    ArrayList ExecArrary = new ArrayList();
+                    if (!DetailDB.ExecuteReader(strDetail, ref ExecArrary, false)) continue;
+                    if (ExecArrary.Count == 0) continue;
+
+                    foreach (object[] CurRec in ExecArrary)
+                    {
+                        int GROUPCOUNT = CommonMotions.cnvInt(CurRec[1]);
+                        int LINECOUNT = CommonMotions.cnvInt(CurRec[2]);
+                        int COLUMNCOUNT = CommonMotions.cnvInt(CurRec[3]);
+                        int MONTHLYSALARY = CommonMotions.cnvInt(CurRec[6]);
+                        int SALARYDays = CommonMotions.cnvInt(CurRec[7]);
+
+                        if (SALARYDays != 0) AfterDays = SALARYDays;
+
+                        int SetSalary = 0;
+                        if (GROUPCOUNT == 9 || GROUPCOUNT == 10)
+                        {
+                            SetSalary = CommonMotions.cnvRound(100000 / 30) * AfterDays;
+                        }
+                        else
+                        {
+                            SetSalary = CommonMotions.cnvRound((MONTHLYSALARY * CommonDefine.s_SalaryCorrection) / 30) * AfterDays;
+                        }
+
+                        if (!ExecDB.UpdateFeild(Constrcode, GROUPCOUNT, LINECOUNT, COLUMNCOUNT, (int)IOConstructionLedgerExcute.TableColumn.PaymentAmount, SetSalary, false))
+                        {
+                            ExecDB.rollback();
+                            return;
+                        }
+                    }
                 }
+
+                ExecDB.commit();
+
+                foreach (object[] wrkRec in arList)
+                {
+                    int Constrcode = CommonMotions.cnvInt(wrkRec[0]);
+                    FormConstructionLedger(Constrcode);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                LedgerDB.close(); LedgerDB = null;
+                DetailDB.close(); DetailDB = null;
+                ExecDB.close(); ExecDB = null;
+            }
+        }
+        #endregion
+
+        #region 工事詳細台帳再計算更新
+        /// <summary>
+        /// 工事詳細台帳再計算更新
+        /// </summary>
+        /// <param name="ConstCode"></param>
+        private void FormConstructionLedger(int ConstCode)
+        {
+            FrmConstructionLedger frm = new FrmConstructionLedger();                    // 工事詳細台帳入力
+            try
+            {
+
+                // 工事コードのセット
+                frm.ConstructionCode = ConstCode;
+
+                // 見えない画面を出す
+                frm.Hide();
+
+                // 再計算処理
+                bool bret = frm.RecalculateLedger;
+
                 // 画面を閉じる
                 frm.Close();
             }
@@ -4531,8 +5131,6 @@
             }
             finally
             {
-                LedgerDB.close(); LedgerDB = null;
-
                 frm.Dispose(); frm = null;
             }
         }
